<template>
  <q-page style="max-width: 750px; margin-inline: auto">
    <HeaderSection
      title="Crea Perfil UC"
      :body="currentHeaderBody"
      bgColor="green"
    />

    <main class="row">
      <div class="col-12 justyfy-evently items-center no-padding">
        <!-- MEMBERS -->
        <Members v-if="currentStep === 0" />
        <!-- DESCRIPTION -->
        <Description v-if="currentStep === 1" />
        <!-- PREVIEW -->
        <div class="q-my-xl">
          <CardProfile v-if="currentStep === 2" />
        </div>
      </div>
    </main>
  </q-page>
  <q-footer class="bg-red text-primary">
    <q-btn-group spread>
      <q-btn
        v-if="currentStep !== 0"
        color="brown"
        label="Enrera"
        icon="chevron_left"
        @click="prevStep"
      />
      <q-btn
        v-if="currentStep < 2"
        color="primary"
        label="Següent"
        icon="chevron_right"
        @click="nextStep"
        :disable="isStepValid"
      />
      <q-btn
        v-else
        color="green"
        label="Desar"
        icon="save"
        @click="saveUCProfile"
      />
    </q-btn-group>
  </q-footer>
</template>

<script setup lang="ts">
import { ref, computed } from 'vue'
import { storeToRefs } from 'pinia'

import { useUCStore } from 'src/stores/UCprofile'
import HeaderSection from 'src/components/mxv/HeaderSection.vue'
import Members from 'src/components/landing-profile/Members.vue'
import Description from 'src/components/landing-profile/Description.vue'
import CardProfile from 'src/components/mxv/CardProfile.vue'

/**
 * UC PROFILE STORE
 */

const store = useUCStore()
const { members, project } = storeToRefs(store)

/**
 * COMPONENT STATE
 */
const currentStep = ref<number>(0)
const headerBody = ref<string[]>([
  "Agefeix els membres que es considerin dins l'Unitat de Convivència. Ex: una Persona, Família, Parella...",
  'Afegeix un  nom,si la vostra UC en té, i una descripció curta de qui sou i quin projecte somnieu.',
  'Previsualització del perfil',
])

/**
 * COMPUTED
 */
const currentHeaderBody = computed(() => {
  return [headerBody.value[currentStep.value]]
})

// VALIDATIONS by each step
const isStepValid = computed(() => {
  switch (currentStep.value) {
    case 0:
      return !(members.value.length > 0)

    case 1:
      return (
        project.value.descriptionShort === '' ||
        project.value.descriptionShort === undefined ||
        project.value.locations.length === 0 ||
        project.value.purposes.length === 0
      )

    default:
      return true
  }
})

/**
 * METHODS
 */
const nextStep = () => {
  currentStep.value++
}
const prevStep = () => {
  currentStep.value--
}

const saveUCProfile = () => {
  store.creatUC()
}
</script>
